REBOL []

install-protocol [

    name: 'wget
    port-id: 80

    stop-at: header-end: join crlf crlf

    on-connected: does [
        write-server rejoin [
            "GET " server/target
            " HTTP/1.0" crlf 
            "Host: " server/host
            crlf crlf
        ]
        print ["connecting to:" server/host]
    ]
    
    on-received: func [data /local pos][
        either integer? stop-at [
            on-response server to-string data
            stop-at: header-end    ; Reset stop-at for next request
        ][  
            ; HTTP header received          
            either pos: find/tail data "Content-Length:" [
                ; Extract document size
                data: to-string trim/all copy/part pos find pos newline
                stop-at: to-integer data
?? stop-at                
            ][
                on-failed server
            ]
        ]
    ]
    
    events: [
        on-response     ; [port [port!] result]
        on-failed       ; [port [port!]]
    ]
]

